<?php

namespace Shavshukov\EventAppBase\Console;

use Shavshukov\EventAppBase\ApplicationInterface;

interface CommandInterface
{
    /**
     * Set application for the use of thme command
     * 
     * @param \Shavshukov\EventAppBase\ApplicationInterface $app
     */
    public function setApplication(ApplicationInterface $app);
    
    /**
     * Display usage information
     * 
     * @return string
     */
    public function usage(): string;
    
    /**
     * Display command help information
     * 
     * @param string $entryFileName
     * @return string
     */
    public function help(string $entryFileName): string;
    
    /**
     * Handle command
     * 
     * @param array $arguments
     * @return \React\Promise\PromiseInterface|mixed
     */
    public function handle(array $arguments);
}
