<?php

namespace Shavshukov\EventAppBase\Service;

use Shavshukov\EventAppBase\ApplicationInterface;

interface ProviderInterface
{
    /**
     * Get Application instance
     * 
     * @return \Shavshukov\EventAppBase\ApplicationInterface
     */
    public function getApplication(): ApplicationInterface;
    
    /**
     * Register services into the container
     * 
     * @param \Shavshukov\EventAppBase\Service\Container $container
     * @param array $registerArguments
     * @return null
     */
    public function register(Container $container, ...$registerArguments);
    
}
